/*
  Q Light Controller
  midiinputdevice.cpp

  Copyright (c) Heikki Junnila

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

      http://www.apache.org/licenses/LICENSE-2.0.txt

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
*/

#include <QDebug>
#include "inputdevice.h"

InputDevice::InputDevice(const QVariant& uid, const QString& name, QObject* parent)
    : IODevice(uid, name, parent)
{
    qDebug() << Q_FUNC_INFO;
}

InputDevice::~InputDevice()
{
    qDebug() << Q_FUNC_INFO;
}

void InputDevice::emitValueChanged(uint channel, uchar value)
{
    emit valueChanged(uid(), channel, value);
}

